//---------------------------------------------------------------------------------
// File Name: RacingAI.h
// Description: 	
//
// Copyright (C) 2004 - 2006 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// Details of this agreement are found in the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------

#ifndef TA_RACINGAI_H
#define TA_RACINGAI_H

#ifndef TA_TYPES_H
#include "../TA/Common/Types.h"
#endif

namespace TA { class DynamicObjectCar; }

class RaceTrack;

class RacingAI
{
public:
	RacingAI();
	~RacingAI();

	void Initialise(TA::DynamicObjectCar& physicsObjectCar, float fSpeed);
	void Finalise();

	void Update(float fDt, const RaceTrack* pRaceTrack);

	bool IsDead() const { return !m_pDynamicObjectCar; }

private:
	TA::DynamicObjectCar* m_pDynamicObjectCar;
	int m_nCurrentTrackSeg;
	float m_fSpeed;
	float m_fTimeStuck;

	void AdvanceSegment(const RaceTrack* pRaceTrack);
};

#endif // TA_RACINGAI_H