//---------------------------------------------------------------------------------
// File Name: ICamera.h
// Description: 	
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// Details of this agreement are found in the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------

#ifndef TA_ICAMERA_H
#define TA_ICAMERA_H

namespace TA
{
	struct Mat33;
	struct Vec3;
}

struct ICamera
{
public:
	virtual void Initialise() = 0;
	virtual void Release() = 0;

	virtual void Realise() = 0;
	virtual const TA::Vec3& GetPosition() const = 0;
	virtual void SetPosition(const TA::Vec3& v3Pos) = 0;
	virtual const TA::Mat33& GetRotation() const = 0;
	virtual void SetRotation(const TA::Mat33& m33Rotation) = 0;
	virtual void SetNearClip(float fNearClip) = 0;
	virtual void SetFarClip(float fFarClip) = 0;
	virtual void SetViewDistance(float fViewDistance) = 0;
	virtual void UpdateRotation(int nX, int nY) = 0;	
	virtual void SetTargetPosition(const TA::Vec3& v3TargetPosition) = 0;
};

#endif // TA_ICAMERA_H
