//---------------------------------------------------------------------------------
// File Name: TAMemoryMgr.cpp
// Description: 
//		Suppling implementation of new and delete used in debug mode.
//		This allows users of TA libraries to do there own memory tracking
//		of TA objects created by the library.
//
// Copyright (C) 2004 - 2005 True Axis Pty Ltd, Australia. 
// All Rights Reserved.
//
// Use of this code is covered by the "TRUE AXIS PHYSICS SDK DEMOS SOURCE LICENSE AGREEMENT".
// Details of this agreement are found in the file "TrueAxisPhysicsSDKDemosSourceLicence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.
//
// History:
//		Created File.
//---------------------------------------------------------------------------------

#ifdef _DEBUG

#include "../TA/Common/MemoryMgr.h"

#include <crtdbg.h>

using namespace TA;

class MyMemoryMgr
{
public:

	//---------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------
	MyMemoryMgr()
	{
		MemoryMgr::SetDbgAlloc(Alloc);
		MemoryMgr::SetDbgFree(Free);
	}

	//---------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------
	~MyMemoryMgr()
	{
		MemoryMgr::SetDbgAlloc(0);
		MemoryMgr::SetDbgFree(0);
	}

	//---------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------
	static void* TAC_CALL Alloc(unsigned int nSize, unsigned int nAlignment, const char * szFileName, int nLine)
	{
		return _aligned_malloc_dbg(nSize, nAlignment, szFileName, nLine);
	}

	//---------------------------------------------------------------------------------
	//---------------------------------------------------------------------------------
	static void TAC_CALL Free(void* pData, const char * szFileName, int nLine)
	{		
		_aligned_free_dbg(pData);
	}
};

static MyMemoryMgr s_myMemoryMgr;



#endif // _DEBUG

